#
# bpk_menu.pl:  bpub keywords for menus
#
#  Menu: returns a menu page (with images and neato mouseover action) after
#        creating the item pages (with headings) for each Mitem
#     content: a block of Mitems
#     name (inheritable): name of the menu
#     title (inheritable): title of the menu
#     align (inheritable): which side of the screen the menu is on,
#                          either "left" or "right"
#
#  Mitem: container for the menu items
#     name: name of the item
#     coords: bounding box on the image where user can click
#     subtext: status bar text to be displayed on mouseover
#     content (optional): the page to be made into the mitem file
#

package Menu;
@ISA = ("Keyword");
$prefixproperty = "name";

sub gettext {
    my ($self) = @_;
    my ($name,$title,$align)= $self->inheritpropertytext(qw(name title align));
    my ($uprefix,$sprefix) = $self->getprefix();
    $self->attachsubpropertytext(qw(content name coords subtext));
    my $contentblock = $$self{content};

    my ($titlesimg,$sketchimg,$compimg) = 
      $self->getimages("images/menus/$uprefix${name}_titles",
		       "images/menus/$uprefix${name}_sketch_none",
		       "images/menus/$uprefix${name}_comp_none");


    ###  create files for each menu item

    foreach $mitem (@$contentblock) {
	next unless exists ($$mitem{content});
	my $filename = "$uprefix${name}_$$mitem{_name}";
	my $file = $mitem->getcreatetext("Htmlfile",
					title => $$mitem{_name},
					content => $mitem->gettext(),
					redirect => $filename);
        $self->createfile("$filename.html",$file);
    }


    ###  create javascript for menu file

    my $compname = $$compimg{name};
    $compname =~ s/_none\./_\'+name+\'./;

    my $script = <<"_eot_";
 if (document.images) {
   sketch_none = new Image($$sketchimg{width},$$sketchimg{height});
   sketch_none.src = '$$sketchimg{name}';
_eot_

    foreach $mitem (@$contentblock) {
	my $imgname = $$sketchimg{name};
	$imgname =~ s/_none\./_$$mitem{_name}./;
	$script .= <<"_eot_";
   sketch_$$mitem{_name} = new Image($$sketchimg{width},$$sketchimg{height});
   sketch_$$mitem{_name}.src = '$imgname';
_eot_
    }

    $script .= <<"_eot_";
 }

 function di(name) {
   if (document.images) {
     document.imgsketch.src = eval('sketch_'+name+'.src');
   }
 }

 function hit(name) {
   if (document.images) {
     document.imgcomp.src = '$compname';
   }
   parent.content.location = '$uprefix${name}_'+name+'.html';
 }

 function dm(msg) {
   window.status=msg;
 }
_eot_


    ###  create body for menu file

    my $body = qq(<map name="menumap">\n);
    foreach $mitem (@$contentblock) { $body .= <<"_eot_"; }
<area shape="RECT" coords="$$mitem{_coords}"
  href="$uprefix${name}_$$mitem{_name}.html"
  target="content" onclick="hit('$$mitem{_name}');return false;"
  onMouseOut="di('none');window.status=' ';return true;"
  onMouseOver="di('$$mitem{_name}');setTimeout('dm(\\'$$mitem{_subtext}\\')',1);dm('$$mitem{_subtext}');return true;">
_eot_

    $body .= <<"_eot_";
</map>

<table cellpadding="0" cellspacing="0" border="0"
  width="$$titlesimg{width}" align="$align">
<tr><td width="$$titlesimg{width}" height="$$titlesimg{height}"
  align="$align"><img
  src="$$titlesimg{name}" width="$$titlesimg{width}"
  height="$$titlesimg{height}" border="0" usemap="#menumap"></td></tr>
<tr><td width="$$sketchimg{width}" height="$$sketchimg{height}"
  align="$align"><img
  src="$$sketchimg{name}" width="$$sketchimg{width}"
  height="$$sketchimg{height}" border="0" name="imgsketch"></td></tr>
<tr><td width="$$compimg{width}" height="$$compimg{height}"
  align="$align"><img
  src="$$compimg{name}" width="$$compimg{width}"
  height="$$compimg{height}" border="0" name="imgcomp"></td></tr>
</table>
_eot_


    ###  put it all together

    my $text = $self->getcreatetext("Htmlfile",
				    border => 1,
				    script => $script,
				    body => $body);
    return $text;
}


package Mitem;
@ISA = ("Container");


1;
