#
# bpk_splash.pl:  generates the splash pages and blank pages
#
#   Splash:  creates all the files for the splash intro and blank pages.
#

package Splash;
@ISA = ("Keyword");

sub gettext {
    my ($self) = @_;

    ### make blank.html

    $self->createfile("blank.html", $self->getcreatetext("Htmlfile"));


    ### make border.html

    $self->createfile("border.html",
		      $self->getcreatetext("Htmlfile", 
					   border => 1, 
					   redirect => "1" ));


    ### make redirect.html

    my $redirect_onload = "checkredirect()";
    my $redirect_script = <<"_eot_";
function checkredirect() {
  if ((top.location.search.length > 5) &&
      (top.location.search.indexOf("/") == -1)) {
    window.location.replace(top.location.search.substr(1));
  }
}
_eot_

    my $redirect = $self->getcreatetext("Htmlfile", border => 1,
					script => $redirect_script,
					onload => $redirect_onload);
    $self->createfile("redirect.html",$redirect);


    ### make splash_links1.html

    my $links1_onload = "setTimeout('flip()',750)";
    my $links1_script = <<"_eot_";
if (document.images) {
  spacer = new Image(2,2);
  spacer.src = 'images/etc/spacer.gif';
  borderspacer = new Image(2,2);
  borderspacer.src = 'images/etc/borderspacer.gif';
}

function flip() {
  self.location.replace("splash_links2.html");
}
_eot_

    my $links1_body = <<"_eot_";
<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="0">
<tr><td align="left" valign="bottom">
<a style="text-decoration:none" 
   href="splash_links2.html"><font color="#ffffff" size="-3">&nbsp; </font></a>
</td></tr></table>
_eot_

    my $links1 = $self->getcreatetext("Htmlfile",
                                      body => $links1_body,
				      script => $links1_script,
				      onload => $links1_onload);
    $self->createfile("splash_links1.html",$links1);


    ### make splash_links2.html

    my $links2_script = <<"_eot_";
function topswap() {
  if (self.location != top.location) {
    top.splashmain.splash_swap();
  }
}
_eot_

    my $links2_body = <<"_eot_";
<center><table cellpadding="0" cellspacing="0" border="0" width="100%">
<tr><td height="16" align="center"><img src="images/etc/spacer.gif"
  width=2 height=16 border="0"></td></tr>
<tr><td height="48" align="center"><a
  href="splash_links3.html" onMouseOut="window.status=' ';return true;"
  onMouseOver="window.status='who are you, boy?';return true;"
  onClick="topswap(); return true;">
  <img src="images/splash/splash_who.jpg"
   width=192 height=48 border="0"></a></td></tr>
<tr><td height="16" align="center"><img src="images/etc/spacer.gif"
  width=2 height=16 border="0"></td></tr>
</table></center>
_eot_

    my $links2 = $self->getcreatetext("Htmlfile",
				      script => $links2_script,
				      body => $links2_body);
    $self->createfile("splash_links2.html",$links2);


    ### make splash_links3.html

    my $links3_script = $links2_script;
    my $links3_onload = "setTimeout('topswap()',400)";
    my $links3_body = <<"_eot_";
<center><table cellpadding="0" cellspacing="0" border="0" width="100%">
<tr><td height="32" align="center"><a href="create_index.html"
  target="_top" onMouseOut="window.status=' ';return true;"
  onMouseOver="window.status='i am what i create...';return true;">
  <img src="images/splash/splash_create.jpg"
   width=205 height=32 border="0"></a></td></tr>
<tr><td height="19" align="center"><img src="images/etc/spacer.gif"
  width=2 height=19 border="0"></td></tr>
<tr><td height="29" align="center"><a href="else_index.html"
  target="_top" onMouseOut="window.status=' ';return true;"
  onMouseOver="window.status='what else is there?';return true;">
  <img src="images/splash/splash_else.jpg"
   width=205 height=32 border="0"></a></td></tr>
</table></center>
_eot_

    my $links3 = $self->getcreatetext("Htmlfile",
				      script => $links3_script,
				      onload => $links3_onload,
				      body => $links3_body);
    $self->createfile("splash_links3.html", $links3);


    ### make splash_main.html

    my $splash_script = <<"_eot_";
if (document.images) {
 splash2 = new Image(405, 180);
 splash2.src = 'images/splash/splash_show.jpg';
}
function splash_swap() {
 if (document.images) {
   document.splash.src=splash2.src;
 }
}
_eot_

    my $splash_body = <<"_eot_";
<center><img src="images/splash/splash_hide.jpg"
  width=405 height=180 name="splash" border="0"></center>
_eot_

    my $splash = $self->getcreatetext("Htmlfile",
				      script => $splash_script,
				      body => $splash_body);
    $self->createfile("splash_main.html", $splash);


    ### make index.html

    my $meta = <<"_eot_";
<meta name="keywords" content="Bret Victor, Bret, Victor, Slixter, Apple IIgs, IIgs, Lloyd Radio, lloydradio, Caltech, Cal Tech, Lloyd House, Lloyd, BA Music, Castro Valley, CVHS, uselessware, Operation Lambda, Opening Line, Textfighter, Surfburgers, Bunnies and Carrots, CokeOS">
<meta name="description" content="Bret Victor's personal website.  Basically, a lot of stuff about the projects he's worked on, some fun stuff, and a bit of personal information.">
_eot_

    my $bpubframeset = <<"_eot_";
frameset(rows="*,440,*" content={
  frame(name="bordertop" border)
  frameset(cols="*,700,*" content={
    frame(name="borderleft" border)
    frameset(rows="*,190,80,*" content={
      frame(name="splashtop" blank)
      frame(name="splashmain" src="splash_main.html")
      frame(name="splashlinks" src="splash_links1.html")
      frame(name="splashbottom" src="splash_updates.html") })
    frame(name="borderright" border) })
  frame(name="borderbottom" border)
})
_eot_

    my $htmlframeset = $self->getparsetext($bpubframeset);
    my $index = $self->getcreatetext("Htmlfile",
				     title => "bretSite",
				     meta => $meta,
				     frameset => $htmlframeset);
    $self->createfile("index.html",$index);

    return "";
}

