#
# bpk_toplevel.pl:  bpub keywords for top-level-ish stuff
#
#  Toplevel: creates the menu file, and generates the topbar and top-level
#            frameset files.
#    name:  name of this section
#    align:  which side of the screen the menu should be on, "left" or "right"
#    menu:  an HTML page to be saved as the menu, typically from the
#           Menu keyword
#

package Toplevel;
@ISA = ("Keyword");

sub gettext {
    my ($self) = @_;
    my ($name,$align,$menu) =
	$self->getpropertytext(qw(name align menu));

    ###  Save menu file

    $self->createfile("${name}_menu.html",$menu);


    ###  Create topbar

    my ($arrow1,$arrow2) = ("rightdownarrow","rightarrow");
    ($arrow1,$arrow2) = ("leftarrow","leftdownarrow") if $align eq 'right';
    my ($arrow1img, $arrow2img, $createimg, $elseimg, $titleimg) =
      $self->getimages("images/topbar/topbar_$arrow1",
		       "images/topbar/topbar_$arrow2",
		       "images/topbar/topbar_create",
		       "images/topbar/topbar_else");

    foreach $img ($arrow1img,$arrow2img) {
	$$img{thin} = $$img{thick} = $$img{name};
	$$img{thick} =~ s/\./_thick./;
    }

    my $spacing = 8;

    my $table1width = $$arrow1img{width} + $$createimg{width} + $spacing;
    my $table2width = $$arrow2img{width} + $$elseimg{width} + $spacing;

    my $topbarscript = <<"_eot_";
if (document.images) {
  arrow1_thin = new Image($$arrow1img{width},$$arrow1img{height});
  arrow1_thin.src = '$$arrow1img{thin}';
  arrow1_thick = new Image($$arrow1img{width},$$arrow1img{height});
  arrow1_thick.src = '$$arrow1img{thick}';
  arrow2_thin = new Image($$arrow2img{width},$$arrow2img{height});
  arrow2_thin.src = '$$arrow2img{thin}';
  arrow2_thick = new Image($$arrow2img{width},$$arrow2img{height});
  arrow2_thick.src = '$$arrow2img{thick}';
}

function ithin(name) {
  if (document.images) {
    document.images[name].src = eval(name+'_thin.src');
  }
}

function ithick(name) {
  if (document.images) {
    document.images[name].src = eval(name+'_thick.src');
  }
}
_eot_

    my $topbarbody = <<"_eot_";
<table cellspacing="0" cellpadding="0" border="0" width="100%">
<tr>

<td width="$table1width" align="left"><table
    cellspacing="0" cellpadding="0" border="0" width="$table1width">
 <tr>

<td align="left" width="$$arrow1img{width}"><a href="create_index.html"
 onMouseOut="ithin('arrow1');window.status=' ';return true;"
 onMouseOver="ithick('arrow1');window.status='i am what i create';return true;"
 target="_top"><img src="$$arrow1img{thin}"
 border="0" width="$$arrow1img{width}" height="$$arrow1img{height}"
 name="arrow1"></a></td>

<td width="$spacing"><img src="images/etc/borderspacer.gif" width="$spacing"
  height="$$arrow1img{height} border="0"></td>

<td align="left" width="$$createimg{width}"><a href="create_index.html"
 onMouseOut="ithin('arrow1');window.status=' ';return true;"
 onMouseOver="ithick('arrow1');window.status='i am what i create';return true;"
 target="_top"><img src="$$createimg{name}"
 border="0" width="$$createimg{width}" height="$$createimg{height}"></a></td>

 </tr></table></td>

<td align="center"><img src="images/etc/borderspacer.gif"
  width="$spacing" height="$$createimg{height}" border="0"></td>

<td width="$table2width" align="right"><table
    cellspacing="0" cellpadding="0" border="0" width="$table2width">
 <tr>

<td align="right" width="$$elseimg{width}"><a href="else_index.html"
 onMouseOut="ithin('arrow2');window.status=' ';return true;"
 onMouseOver="ithick('arrow2');window.status='what else is there?';return true;"
 target="_top"><img src="$$elseimg{name}"
 border="0" width="$$elseimg{width}" height="$$elseimg{height}"></a></td>

<td width="$spacing"><img src="images/etc/borderspacer.gif" width="$spacing"
  height="$$arrow2img{height} border="0"></td>

<td align="right" width="$$arrow2img{width}"><a href="else_index.html"
 onMouseOut="ithin('arrow2');window.status=' ';return true;"
 onMouseOver="ithick('arrow2');window.status='what else is there?';return true;"
 target="_top"><img src="$$arrow2img{thin}"
 border="0" width="$$arrow2img{width}" height="$$arrow2img{height}"
 name="arrow2"></a></td>

 </tr></table></td>

</tr>
</table>
_eot_

    my $topbarfile = $self->getcreatetext("Htmlfile",
					  script => $topbarscript,
					  border => 1,
					  body => $topbarbody );

    $self->createfile("${name}_topbar.html",$topbarfile);


    ###  Create top-level frameset

    my $contentcols = "260,*";
    my $frame1 = qq( frame(name="menu" src="${name}_menu.html") );
    my $frame2 = qq( frameset(rows="20,*" content={
                     frame(name="topspace" border)
                     frame(name="content" scroll src="redirect.html") }) );
    if ($align eq "right") {
	$contentcols = "*,260";
	($frame1,$frame2) = ($frame2,$frame1);
    }

    my $bpubframeset = <<"_eot_";
frameset(rows="*,440,*" content={
  frame(name="bordertop" border)
  frameset(cols="*,700,*" content={
    frame(name="borderleft" border)
    frameset(rows="25,*" content={
      frame(name="topbar" src="${name}_topbar.html")
      frameset(cols="$contentcols" content={
        $frame1
        $frame2
      }) })
    frame(name="borderright" border) })
  frame(name="borderbottom" border)
})
_eot_

    my $htmlframeset = $self->getparsetext($bpubframeset);
    my $framesetfile = $self->getcreatetext("Htmlfile",
					    title => "bretSite",
					    frameset => $htmlframeset);

    $self->createfile("${name}_index.html",$framesetfile);

    return "";
}


1;
